1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
84 my $ok = join("|", qw(
95 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
96 print join("\n", @vars);
100 GIT_AUTHOR_EMAIL=author@example.com
101 GIT_AUTHOR_NAME='A U Thor'
102 GIT_COMMITTER_EMAIL=committer@example.com
103 GIT_COMMITTER_NAME='C O Mitter'
104 GIT_MERGE_VERBOSITY=5
105 GIT_MERGE_AUTOEDIT=no
106 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
107 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
108 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
111 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
113 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
114 export GIT_INDEX_VERSION
117 # Add libc MALLOC and MALLOC_PERTURB test
118 # only if we are not executing the test with valgrind
119 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
120 test -n "$TEST_NO_MALLOC_CHECK"
122 setup_malloc_check () {
125 teardown_malloc_check () {
129 setup_malloc_check () {
130 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
131 export MALLOC_CHECK_ MALLOC_PERTURB_
133 teardown_malloc_check () {
134 unset MALLOC_CHECK_ MALLOC_PERTURB_
138 # Protect ourselves from common misconfiguration to export
139 # CDPATH into the environment
145 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
147 echo "* warning: Some tests will not work if GIT_TRACE" \
148 "is set as to trace on STDERR ! *"
149 echo "* warning: Please set GIT_TRACE to something" \
150 "other than 1, 2 or true ! *"
156 # A regexp to match 5 and 40 hexdigits
157 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
158 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
161 _z40=0000000000000000000000000000000000000000
167 export _x05 _x40 _z40 LF
169 # Each test should start with something like this, after copyright notices:
171 # test_description='Description of this test...
172 # This test checks if command xyzzy does the right thing...
175 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
176 TERM=$ORIGINAL_TERM &&
179 tput bold >/dev/null 2>&1 &&
180 tput setaf 1 >/dev/null 2>&1 &&
181 tput sgr0 >/dev/null 2>&1
185 while test "$#" -ne 0
188 -d|--d|--de|--deb|--debu|--debug)
190 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
191 immediate=t; shift ;;
192 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
193 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
194 -h|--h|--he|--hel|--help)
196 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
199 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
201 -q|--q|--qu|--qui|--quie|--quiet)
202 # Ignore --quiet under a TAP::Harness. Saying how many tests
203 # passed without the ok/not ok details is always an error.
204 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
206 with_dashes=t; shift ;;
209 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
213 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
216 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
219 shift ;; # was handled already
221 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
224 echo "error: unknown test option '$1'" >&2; exit 1 ;;
228 if test -n "$valgrind_only"
230 test -z "$valgrind" && valgrind=memcheck
231 test -z "$verbose" && verbose_only="$valgrind_only"
232 elif test -n "$valgrind"
245 tput bold; tput setaf 1;; # bold red
247 tput setaf 4;; # blue
249 tput setaf 3;; # brown/yellow
251 tput setaf 2;; # green
253 tput setaf 6;; # cyan
255 test -n "$quiet" && return;;
265 test -z "$1" && test -n "$quiet" && return
272 say_color error "error: $*"
281 test "${test_description}" != "" ||
282 error "Test script did not set test_description."
284 if test "$help" = "t"
286 printf '%s\n' "$test_description"
292 if test "$verbose" = "t"
296 exec 4>/dev/null 3>/dev/null
305 test_external_has_tap=0
309 if test -n "$GIT_EXIT_OK"
313 echo >&5 "FATAL: Unexpected exit with code $code"
321 # The user-facing functions are loaded from a separate file so that
322 # test_perf subshells can have them too
323 . "$TEST_DIRECTORY/test-lib-functions.sh"
325 # You are not expected to call test_ok_ and test_failure_ directly, use
326 # the test_expect_* functions instead.
329 test_success=$(($test_success + 1))
330 say_color "" "ok $test_count - $@"
334 test_failure=$(($test_failure + 1))
335 say_color error "not ok $test_count - $1"
337 printf '%s\n' "$*" | sed -e 's/^/# /'
338 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
341 test_known_broken_ok_ () {
342 test_fixed=$(($test_fixed+1))
343 say_color error "ok $test_count - $@ # TODO known breakage vanished"
346 test_known_broken_failure_ () {
347 test_broken=$(($test_broken+1))
348 say_color warn "not ok $test_count - $@ # TODO known breakage"
352 test "$debug" = "" || eval "$1"
355 match_pattern_list () {
358 test -z "$*" && return 1
369 maybe_teardown_verbose () {
370 test -z "$verbose_only" && return
371 exec 4>/dev/null 3>/dev/null
376 maybe_setup_verbose () {
377 test -z "$verbose_only" && return
378 if match_pattern_list $test_count $verbose_only
381 # Emit a delimiting blank line when going from
382 # non-verbose to verbose. Within verbose mode the
383 # delimiter is printed by test_expect_*. The choice
384 # of the initial $last_verbose is such that before
385 # test 1, we do not print it.
386 test -z "$last_verbose" && echo >&3 ""
389 exec 4>/dev/null 3>/dev/null
392 last_verbose=$verbose
395 maybe_teardown_valgrind () {
396 test -z "$GIT_VALGRIND" && return
397 GIT_VALGRIND_ENABLED=
400 maybe_setup_valgrind () {
401 test -z "$GIT_VALGRIND" && return
402 if test -z "$valgrind_only"
404 GIT_VALGRIND_ENABLED=t
407 GIT_VALGRIND_ENABLED=
408 if match_pattern_list $test_count $valgrind_only
410 GIT_VALGRIND_ENABLED=t
415 # This is a separate function because some tests use
416 # "return" to end a test_expect_success block early.
417 eval </dev/null >&3 2>&4 "$*"
426 teardown_malloc_check
428 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
431 test_eval_ "$test_cleanup"
432 teardown_malloc_check
434 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
442 test_count=$(($test_count+1))
449 maybe_teardown_valgrind
450 maybe_teardown_verbose
455 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
459 if test -z "$to_skip" && test -n "$test_prereq" &&
460 ! test_have_prereq "$test_prereq"
467 if test "$missing_prereq" != "$test_prereq"
469 of_prereq=" of $test_prereq"
472 say_color skip >&3 "skipping test: $@"
473 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
482 # stub; perf-lib overrides it
483 test_at_end_hook_ () {
490 if test -z "$HARNESS_ACTIVE"
492 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
493 mkdir -p "$test_results_dir"
495 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
497 cat >>"$test_results_path" <<-EOF
499 success $test_success
507 if test "$test_fixed" != 0
509 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
511 if test "$test_broken" != 0
513 say_color warn "# still have $test_broken known breakage(s)"
515 if test "$test_broken" != 0 || test "$test_fixed" != 0
517 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
518 msg="remaining $test_remaining test(s)"
520 test_remaining=$test_count
521 msg="$test_count test(s)"
523 case "$test_failure" in
525 # Maybe print SKIP message
526 if test -n "$skip_all" && test $test_count -gt 0
528 error "Can't use skip_all after running some tests"
530 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
532 if test $test_external_has_tap -eq 0
534 if test $test_remaining -gt 0
536 say_color pass "# passed all $msg"
538 say "1..$test_count$skip_all"
541 test -d "$remove_trash" &&
542 cd "$(dirname "$remove_trash")" &&
543 rm -rf "$(basename "$remove_trash")"
550 if test $test_external_has_tap -eq 0
552 say_color error "# failed $test_failure among $msg"
561 if test -n "$valgrind"
565 test "$1" = "$(readlink "$2")" || {
573 while test -d "$2".lock
575 say "Waiting for lock on $2."
582 make_valgrind_symlink () {
583 # handle only executables, unless they are shell libraries that
584 # need to be in the exec-path.
586 test "# " = "$(head -c 2 <"$1")" ||
589 base=$(basename "$1")
590 symlink_target=$GIT_BUILD_DIR/$base
591 # do not override scripts
592 if test -x "$symlink_target" &&
593 test ! -d "$symlink_target" &&
594 test "#!" != "$(head -c 2 < "$symlink_target")"
596 symlink_target=../valgrind.sh
600 symlink_target=../unprocessed-script
602 # create the link, or replace it if it is out of date
603 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
606 # override all git executables in TEST_DIRECTORY/..
607 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
608 mkdir -p "$GIT_VALGRIND"/bin
609 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
611 make_valgrind_symlink $file
613 # special-case the mergetools loadables
614 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
619 ls "$path"/git-* 2> /dev/null |
622 make_valgrind_symlink "$file"
626 PATH=$GIT_VALGRIND/bin:$PATH
627 GIT_EXEC_PATH=$GIT_VALGRIND/bin
629 GIT_VALGRIND_MODE="$valgrind"
630 export GIT_VALGRIND_MODE
631 GIT_VALGRIND_ENABLED=t
632 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
633 export GIT_VALGRIND_ENABLED
634 elif test -n "$GIT_TEST_INSTALLED"
636 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
637 error "Cannot run git from $GIT_TEST_INSTALLED."
638 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
639 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
640 else # normal case, use ../bin-wrappers only unless $with_dashes:
641 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
642 if ! test -x "$git_bin_dir/git"
644 if test -z "$with_dashes"
646 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
650 PATH="$git_bin_dir:$PATH"
651 GIT_EXEC_PATH=$GIT_BUILD_DIR
652 if test -n "$with_dashes"
654 PATH="$GIT_BUILD_DIR:$PATH"
657 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
658 GIT_CONFIG_NOSYSTEM=1
660 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
662 if test -z "$GIT_TEST_CMP"
664 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
666 GIT_TEST_CMP="$DIFF -c"
668 GIT_TEST_CMP="$DIFF -u"
672 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
674 test -d "$GIT_BUILD_DIR"/templates/blt || {
675 error "You haven't built things yet, have you?"
678 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
680 echo >&2 'You need to build test-chmtime:'
681 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
686 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
687 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
688 case "$TRASH_DIRECTORY" in
689 /*) ;; # absolute path is good
690 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
692 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
693 rm -fr "$TRASH_DIRECTORY" || {
695 echo >&5 "FATAL: Cannot prepare test area"
699 HOME="$TRASH_DIRECTORY"
702 if test -z "$TEST_NO_CREATE_REPO"
704 test_create_repo "$TRASH_DIRECTORY"
706 mkdir -p "$TRASH_DIRECTORY"
708 # Use -P to resolve symlinks in our working directory so that the cwd
709 # in subprocesses like git equals our $PWD (for pathname comparisons).
710 cd -P "$TRASH_DIRECTORY" || exit 1
713 this_test=${this_test%%-*}
714 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
716 say_color info >&3 "skipping test $this_test altogether"
717 skip_all="skip all tests in $this_test"
721 # Provide an implementation of the 'yes' utility
736 # Fix some commands on Windows
739 # Windows has its own (incompatible) sort and find
749 # git sees Windows-style pwd
753 # no POSIX permissions
754 # backslashes in pathspec are converted to '/'
755 # exec does not inherit the PID
756 test_set_prereq MINGW
757 test_set_prereq NOT_CYGWIN
758 test_set_prereq SED_STRIPS_CR
759 test_set_prereq GREP_STRIPS_CR
760 GIT_TEST_CMP=mingw_test_cmp
763 test_set_prereq POSIXPERM
764 test_set_prereq EXECKEEPSPID
765 test_set_prereq NOT_MINGW
766 test_set_prereq CYGWIN
767 test_set_prereq SED_STRIPS_CR
768 test_set_prereq GREP_STRIPS_CR
771 test_set_prereq POSIXPERM
772 test_set_prereq BSLASHPSPEC
773 test_set_prereq EXECKEEPSPID
774 test_set_prereq NOT_MINGW
775 test_set_prereq NOT_CYGWIN
779 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
780 test -z "$NO_PERL" && test_set_prereq PERL
781 test -z "$NO_PYTHON" && test_set_prereq PYTHON
782 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
783 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
785 # Can we rely on git's output in the C locale?
786 if test -n "$GETTEXT_POISON"
788 GIT_GETTEXT_POISON=YesPlease
789 export GIT_GETTEXT_POISON
790 test_set_prereq GETTEXT_POISON
792 test_set_prereq C_LOCALE_OUTPUT
795 # Use this instead of test_cmp to compare files that contain expected and
796 # actual output from git commands that can be translated. When running
797 # under GETTEXT_POISON this pretends that the command produced expected
800 test -n "$GETTEXT_POISON" || test_cmp "$@"
803 # Use this instead of "grep expected-string actual" to see if the
804 # output from a git command that can be translated either contains an
805 # expected string, or does not contain an unwanted one. When running
806 # under GETTEXT_POISON this pretends that the command produced expected
809 if test -n "$GETTEXT_POISON"
812 elif test "x!" = "x$1"
821 test_lazy_prereq PIPE '
822 # test whether the filesystem supports FIFOs
828 rm -f testfifo && mkfifo testfifo
833 test_lazy_prereq SYMLINKS '
834 # test whether the filesystem supports symbolic links
835 ln -s x y && test -h y
838 test_lazy_prereq FILEMODE '
839 test "$(git config --bool core.filemode)" = true
842 test_lazy_prereq CASE_INSENSITIVE_FS '
843 echo good >CamelCase &&
844 echo bad >camelcase &&
845 test "$(cat CamelCase)" != good
848 test_lazy_prereq UTF8_NFD_TO_NFC '
849 # check whether FS converts nfd unicode to nfc
850 auml=$(printf "\303\244")
851 aumlcdiar=$(printf "\141\314\210")
861 test_lazy_prereq AUTOIDENT '
862 sane_unset GIT_AUTHOR_NAME &&
863 sane_unset GIT_AUTHOR_EMAIL &&
864 git var GIT_AUTHOR_IDENT
867 # When the tests are run as root, permission tests will report that
868 # things are writable when they shouldn't be.
869 test -w / || test_set_prereq SANITY
871 GIT_UNZIP=${GIT_UNZIP:-unzip}
872 test_lazy_prereq UNZIP '